SystemOrganization addCategory: #YahooFinance!
SystemOrganization addCategory: #'YahooFinance-Utils'!

Object subclass: #YFObject
	instanceVariableNames: 'symbol comment value change timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'YahooFinance-Utils'!

YFObject subclass: #YFCurrency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'YahooFinance-Utils'!

!YFCurrency methodsFor: 'printing' stamp: 'SR 04/19/2009 07:34'!
printOn: aStream
	self symbol isEmptyOrNil ifTrue: [ ^ self ].
	aStream 
		nextPutAll: self symbol;
		nextPutAll: '=X'! !

!YFObject methodsFor: 'comparing' stamp: 'SR 04/19/2009 07:23'!
= aYFObject
	^ self class = aYFObject class
		and: [ self symbol = aYFObject symbol ]! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:56'!
change
	^ change! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:56'!
comment
	^ comment! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:56'!
comment: anObject
	comment := anObject! !

!YFObject methodsFor: 'comparing' stamp: 'SR 04/19/2009 07:23'!
hash
	^ self class hash bitXor: self symbol hash! !

!YFObject methodsFor: 'testing' stamp: 'SR 04/19/2009 07:01'!
isValid
	^ self symbol isEmptyOrNil not! !

!YFObject methodsFor: 'testing' stamp: 'SR 04/19/2009 08:18'!
match: aSymbol
	^ self symbol asLowercase = aSymbol asLowercase 
		or: [ ('^', self symbol asLowercase) = aSymbol asLowercase ]! !

!YFObject methodsFor: 'testing' stamp: 'SR 04/19/2009 07:52'!
matchCurrency: aSymbol
	^ self class = YFCurrency 
		and: [ self match: aSymbol ]! !

!YFObject methodsFor: 'testing' stamp: 'SR 04/19/2009 07:51'!
matchQuote: aSymbol
	^ self class = YFQuote
		and: [ self match: aSymbol ]! !

!YFObject methodsFor: 'initializing' stamp: 'SR 04/19/2009 07:04'!
setChange: aFloat
	change := aFloat! !

!YFObject methodsFor: 'initializing' stamp: 'SR 04/19/2009 07:03'!
setValue: aFloat
	value := aFloat! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:55'!
symbol
	^ symbol! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:55'!
symbol: anObject
	symbol := anObject! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 07:05'!
timestamp
	^ timestamp! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 06:55'!
value
	^ value! !

!YFObject methodsFor: 'accessing' stamp: 'SR 04/19/2009 07:03'!
value: aFloat1 change: aFloat2
	self setValue: aFloat1.
	self setChange: aFloat2.
	timestamp := TimeStamp now.! !

YFObject subclass: #YFQuote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'YahooFinance-Utils'!

!YFQuote methodsFor: 'printing' stamp: 'SR 04/19/2009 07:36'!
printOn: aStream
	self symbol isEmptyOrNil ifTrue: [ ^ self ].
	aStream 
		nextPut: $^;
		nextPutAll: self symbol
		! !

Object subclass: #YFQuery
	instanceVariableNames: 'document timestamp parameters dirty interval'
	classVariableNames: 'LastQuery'
	poolDictionaries: ''
	category: 'YahooFinance'!

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 07:48'!
addCurrency: aSymbol
	self parameters add: (YFCurrency new symbol: aSymbol; yourself).
	self dirty: true! !

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 09:22'!
addCurrencyFrom: aSymbol to: anotherSymbol
	(aSymbol isEmptyOrNil or: [ anotherSymbol isEmptyOrNil ]) ifTrue: [ ^ self ].
	self addCurrency: (aSymbol, anotherSymbol)! !

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 07:48'!
addQuote: aSymbol
	self parameters add: (YFQuote new symbol: aSymbol; yourself).
	self dirty: true! !

!YFQuery methodsFor: 'private' stamp: 'SR 04/19/2009 09:03'!
basicDocument
	(LastQuery ifNotNil: [ LastQuery timestamp + self interval <= TimeStamp now ] ifNil: [ true ]) ifFalse: [ ^ document ].
	LastQuery := self.
	timestamp := TimeStamp now.
	self dirty: false.
	^ self parseDocument: (HTTPSocket httpGetDocument: self url)! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:41'!
basicParseChange: aString
	| change |
	change := aString.
	#('-' '+' '%') do: [ :each | change := change copyReplaceAll: each with: '' ].
	change := change asNumber.
	(aString includes: $-) ifTrue: [ change := change negative ].
	^ change! !

!YFQuery methodsFor: 'accessing-defaults' stamp: 'SR 04/19/2009 07:46'!
defaultInterval
	^ 15 minutes! !

!YFQuery methodsFor: 'accessing-defaults' stamp: 'SR 04/19/2009 09:11'!
defaultTimeout
	^ 2 seconds! !

!YFQuery methodsFor: 'private' stamp: 'SR 04/19/2009 07:40'!
dirty
	^ dirty ifNil: [ dirty := true ]! !

!YFQuery methodsFor: 'private' stamp: 'SR 04/19/2009 07:42'!
dirty: aBoolean
	dirty := aBoolean! !

!YFQuery methodsFor: 'accessing' stamp: 'SR 04/19/2009 08:49'!
document
	document ifNil: [ self ensureQuotes ].
	^ document! !

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 08:55'!
ensureQuotes
	document := self basicDocument! !

!YFQuery methodsFor: 'accessing' stamp: 'SR 04/19/2009 07:45'!
interval
	^ interval ifNil: [ interval := self defaultInterval ]! !

!YFQuery methodsFor: 'accessing' stamp: 'SR 04/19/2009 09:11'!
interval: aDuration
	^ interval := interval! !

!YFQuery methodsFor: 'testing' stamp: 'SR 04/19/2009 07:43'!
isDirty
	^ self dirty or: [ self isOutdated ]! !

!YFQuery methodsFor: 'testing' stamp: 'SR 04/19/2009 07:45'!
isOutdated
	^ self timestamp isNil
		or: [ self timestamp + self defaultInterval <= TimeStamp now ]! !

!YFQuery methodsFor: 'private' stamp: 'SR 04/19/2009 07:26'!
parameters
	^ parameters ifNil: [ parameters := Set new ]! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:42'!
parseChange: aString
	^ [ self basicParseChange: aString ] on: Error do: [ nil ]! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:41'!
parseComment: aString
	^ aString! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 09:07'!
parseDocument: aDocument
	aDocument ifNotNil: [ self parseString: aDocument content ].
	^ aDocument! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:20'!
parseLine: aString
	| stream tokens |
	tokens := OrderedCollection new.
	stream := aString readStream.
	stream upTo: $". tokens add: (stream upTo: $"). " comment "
	stream upTo: $". tokens add: (stream upTo: $"). " symbol "
	stream upTo: $,. tokens add: (stream upTo: $,). " value "
	stream upTo: $". tokens add: (stream upTo: $"). " change "
	self parseTokens: tokens! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:00'!
parseString: aString
	aString linesDo: [ :line | self parseLine: line ]! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:42'!
parseTokens: aCollection
	aCollection size < 4 ifTrue: [ ^ self ]. " nothing here "
	(self quotes detect: [ :each | each match: aCollection second ] ifNone: [ ^ self ])
		comment: (self parseComment: aCollection first);
		value: (self parseValue: aCollection third)
		change: (self parseChange: aCollection fourth)! !

!YFQuery methodsFor: 'private-parsing' stamp: 'SR 04/19/2009 08:41'!
parseValue: aString
	^ [ aString asNumber ] on: Error do: [ nil ]! !

!YFQuery methodsFor: 'printing' stamp: 'SR 04/19/2009 07:34'!
printOn: aStream
	aStream nextPutAll: 'http://download.finance.yahoo.com/d/quotes.csv?s='.
	self printParametersOn: aStream.
	aStream nextPutAll: '&f=nsl1p2&e=.csv'! !

!YFQuery methodsFor: 'printing' stamp: 'SR 04/19/2009 07:35'!
printParametersOn: aStream
	self validParameters 
		do: [ :each | each printOn: aStream ] 
		separatedBy: [ aStream nextPut: $+ ]! !

!YFQuery methodsFor: 'accessing' stamp: 'SR 04/19/2009 08:49'!
quotes
	self ensureQuotes.
	^ self parameters ! !

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 07:49'!
removeCurrency: aSymbol
	self parameters removeAllSuchThat: [ :each | each matchCurrency: aSymbol ].
	self dirty: true! !

!YFQuery methodsFor: 'accessing-quotes' stamp: 'SR 04/19/2009 07:50'!
removeQuote: aSymbol
	self parameters removeAllSuchThat: [ :each | each matchQuote: aSymbol ].
	self dirty: true! !

!YFQuery methodsFor: 'accessing' stamp: 'SR 04/19/2009 07:37'!
timestamp
	^ timestamp! !

!YFQuery methodsFor: 'accessing-dynamic' stamp: 'SR 04/19/2009 07:38'!
url
	^ String streamContents: [ :stream | self printOn: stream ]! !

!YFQuery methodsFor: 'private' stamp: 'SR 04/19/2009 07:25'!
validParameters
	^ self parameters select: [ :each | each isValid ]! !
